/*
  Copyright (C) 2005 MARTIN Loc & VINCENT Cdric
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

MODULE_LICENSE("GPL\0 rulez !!!");
MODULE_AUTHOR("VINCENT MARTIN");
MODULE_DESCRIPTION("dummy");
MODULE_SUPPORTED_DEVICE("dummy");

#ifndef DUMMY_H
#define DUMMY_H

//! numro du majeur de notre pilote, \em 0 pour qu'il soit automatiquement dlivr par le noyau.
#define DUMMY_MAJOR 0

//! taille d'un bloc lmentaire pour l'criture dans un priphrique.
#define BUF_SIZE 1024

//! \em 1 si l'on souhaite afficher les messages de deboguage, \em 0 sinon.
#define DEBUG 1

//! lment de la liste des donnes enregistres.
struct element_fifo 
{
        size_t used_bytes; //!< nombre d'octets deja crits dans cet lment.
	char buffer[BUF_SIZE]; //!< zone mmoire o sont stockes les donnes.
        int position; //!< index sur le caractre suivant  lire.
	struct element_fifo *next; //!< pointeur sur l'lment suivant.
	struct element_fifo *prev; //!< pointeur sur l'lment prcdant.
};

//! structure prive propre  chaque priphrique.
struct private_dummy
{
        int index; //!< numro du priphriques.
	int in_use; //!< indique si le priphrique est en cours d'utilisation.
	struct element_fifo *head; //!< pointeur de tte de la liste des donnes enregistres.
	struct semaphore in_use_critique; //!< smaphore de protection de la variable \ref in_use.
	struct semaphore rw_critique; //!< smaphore de protection de la liste pointe par \ref head
};

static int dummy_open (struct inode *inode, struct file *file);
static int dummy_release (struct inode *inode, struct file *file);
static ssize_t dummy_write (struct file *file, const char *buffer, size_t size, loff_t *offset);
static ssize_t dummy_read (struct file *file, char *buffer, size_t size, loff_t *offset);
static int dummy_init(void);
static void dummy_cleanup(void);

//! dclaration des oprations applicables sur le priphrique.
static struct file_operations dummy_fops = {
	read: dummy_read,
	write:  dummy_write,
	open:  dummy_open,
	release: dummy_release,
};

//! nombre priphriques.
static int DeviceCount = 2; 

//! nom des priphriques.
static char *DeviceName = "dummy";

//! valeur du majeur donn par devfs.
static int dummy_major = DUMMY_MAJOR;

//! tableau d'etat des fichiers speciaux ouverts. 
static int *already_opened = NULL;

//! semaphore de protection du tableau d'etat des fichiers speciaux ouverts.
static struct semaphore *open_critique = NULL;

//! pointeur sur la structure de la pile du priphrique.
static struct private_dummy *device_fifo = NULL;

#endif //DUMMY_H
